local mapa = {}

player = {
  px = 100,
  py = 200,
  pulando = false,
  pulando_tempo = 0,
  erro_x = 0,
  erro_y= 0
}

function LoadMap(filename)  
  local file = io.open(filename)
  local i = 1
  for line in file:lines() do
    mapa[i] = {}
    for j=1, #line, 1 do
      mapa[i][j] = line:sub(j,j)
    end
    i = i + 1
  end
  file:close()
end

function love.load()
  LoadMap("Mapa.txt")
end

function love.update(dt)
  player.erro_x = math.floor(player.px % 32)
  player.erro_y = math.floor(player.py % 32)
  
  local py_value = player.py
  
  if player.erro_x ~= 0 then -- gravidade
    if mapa[math.floor(player.py/32)][math.floor((player.px - player.erro_x)/32)] == 'A' and mapa[math.floor(player.py/32)][math.floor((player.px + math.abs(player.erro_x - 32))/32) ] == 'A' then
      player.py = player.py + (200 * dt)
    else
      player.pulando = false
      player.pulando_tempo = 0
    end
  else
    if mapa[math.floor(player.py/32)][math.floor((player.px + math.abs(player.erro_x - 32))/32) ] == 'A' then
      player.py = player.py + (200 * dt)
    else
      player.pulando = false
      player.pulando_tempo = 0
    end  
  end
  
  if love.keyboard.isDown("right") then 
    if player.erro_y ~= 0 then
      if mapa[math.floor((player.py + math.abs(player.erro_y - 32))/32)-2][math.floor(player.px/32)+1] == 'A' and mapa[math.floor((player.py - (player.erro_y))/32)][math.floor((player.px)/32)+1] == 'A' then
        player.px = player.px + (100 * dt)
      end
    else
      if mapa[math.floor((player.py + math.abs(player.erro_y - 32))/32)-2][math.floor(player.px/32)+1] == 'A' then
        player.px = player.px + (100 * dt)
      end 
    end    
  end
  
  if love.keyboard.isDown("left") then
    if player.erro_y ~= 0 then
      if mapa[math.floor((player.py + math.abs(player.erro_y - 32))/32)-2][math.floor(player.px/32)] == 'A' and mapa[math.floor((player.py - (player.erro_y))/32)][math.floor((player.px)/32)] == 'A' then
        player.px = player.px - (100 * dt)
      end
    else
      if mapa[math.floor((player.py + math.abs(player.erro_y - 32))/32)-2][math.floor(player.px/32)] == 'A' then
        player.px = player.px - (100 * dt)
      end 
    end   
  end 
   
  if love.keyboard.isDown("up") and not player.pulando then 
    player.pulando = true
  end
  
  if player.pulando then    
    player.pulando_tempo = player.pulando_tempo + dt
    if player.pulando_tempo < 0.3 then
      player.py = player.py - (400 * dt)      
    end
  end  
    
  if py_value == player.py and player.erro_y > 0 then  
    player.py = player.py - player.erro_y
  end
end

function love.draw()
  for i=1, 17, 1 do  
    for j=1, 23, 1 do
      if (mapa[i][j] == "P") then
        love.graphics.setColor(230,235,134)
      elseif (mapa[i][j] == "G") then
        love.graphics.setColor(39,153,0)
      elseif (mapa[i][j] == "A") then
        love.graphics.setColor(63,125,232)
      end
      love.graphics.rectangle("fill", (j * 32), (i * 32), 32, 32)
    end
  end
  love.graphics.setColor(255,0,0)
  love.graphics.rectangle("fill", player.px, player.py, 32, -64)
end

